************************************************************
*                                                          *
*                       Stata中文分词系统                  *
*                                                          *
************************************************************
/*1、Stata进行分词*/
************

/*ustrwordcount(s[,loc])*/
************
di ustrwordcount("爬虫俱乐部全体成员祝Stata大会越来越好", "cn")

/*ustrword(s,n[,loc])*/
************
di ustrword("爬虫俱乐部全体成员祝Stata大会越来越好", 1, "cn")                      
di ustrword("爬虫俱乐部全体成员祝Stata大会越来越好", 2, "cn") 
di ustrword("爬虫俱乐部全体成员祝Stata大会越来越好",-1, "cn") 
di ustrword("爬虫俱乐部全体成员祝Stata大会越来越好",-2, "cn")

********将ustrwordcount与ustrword结合进行分词
clear
set obs 1
gen v="爬虫俱乐部全体成员祝Stata大会越来越好"
gen v1 = ""
forvalues i = 1/`=ustrwordcount("`=v[1]'","cn")' {
	replace v1 = v1 + ustrword("`=v[1]'", `i', "cn") + " " 
}
*************对文本进行分词以及词频统计
clear 
cd E:\Stata大会\文本分析
tempname temp
file open `temp' using 荷塘月色.txt, write text replace
file write `temp' "曲曲折折的荷塘上面，弥望的是田田的叶子。" _n
file write `temp' "叶子出水很高，像亭亭的舞女的裙。" 
file close `temp'
type 荷塘月色.txt
set obs 1
gen v = fileread("荷塘月色.txt")
gen v1 = ""
forvalues i = 1/`=ustrwordcount("`=v[1]'","cn")' {
	replace v1 = v1 + ustrword("`=v[1]'", `i', "cn") + " "
}

***********词频统计
drop v
rename v1 v
split v,p(" ")
drop v
sxpose,clear
rename _var1 keyword
levelsof keyword, local(keyword)
bysort keyword: gen frequency = _N
duplicates drop

*******************************************************************************
*                                                                              *
*                                    *结束*                                  
*                                                                              *
********************************************************************************
