************************************************************
*                                                          *
*                       词云图                  		   *
*                                                          *
***********************************************************
*********************延伸以大众点评日料评论为例
clear
cd E:\Stata大会\文本分析
cap mkdir "E:\Stata大会\文本分析\词云图"
cap mkdir "E:\Stata大会\文本分析\词云图\大众点评"
use 大众点评日料评论sample.dta, clear
local N=_N
forval i=1/`N'{
	use E:\Stata大会\文本分析/大众点评日料评论sample.dta,clear
	local a=comments[`i']
	di "`a' "
	clear all
	cd  "E:\Stata大会\文本分析\词云图\大众点评"
	tempname handle
	file open `handle' using 分词.py, replace text write
	file write `handle' `"# -*- coding: utf-8 -*-"' _n
	file write `handle' `"import jieba.posseg"' _n
	file write `handle' `"jieba.load_userdict("E:/Stata教程/文本分析/dict.txt")"' _n
	file write `handle' `"string ='`a''"'_n
	file write `handle' `"seg_list = jieba.posseg.cut(string)"' _n
	file write `handle' `"f=open("分词结果`i'.txt","w",encoding="utf-8")"' _n
	file write `handle' `"for word in seg_list:"' _n
	file write `handle' `"	f.write(word.word+" "+word.flag+"\n")"' _n
	file write `handle' `"f.close"'             
	file close `handle'
	! python 分词.py 
}
forval i=1/100{
	clear
	cd  "E:\Stata大会\文本分析\词云图\大众点评"
	infix strL v 1-12000 using 分词结果`i'.txt,clear
	split v,p(" ")
	drop v 
	rename (v1 v2) (keyword flag)
	save 分词结果`i',replace
	}
clear
openall
********
*保留名词动词形容词
replace flag=subinstr(flag," ","",1)
keep if ustrregexm(flag, "^[anv]")
*删除单字
drop if ustrlen(keyword) == 1
compress
keep keyword

*删除停用词
preserve
cd E:\Stata大会\文本分析
import delimited using 停用词表.txt, clear ///
	encoding("utf-8") varname(nonames)
outsheet using 停用词表.txt, replace nonames noquote
levelsof v1, local(keyword)
restore
foreach word in `keyword' {
	drop if keyword == "`word'"
}

*统计词频
bysort keyword: gen frequency = _N
duplicates drop
gsort -frequency
wordcloud keyword frequency using 词云.html , replace ///
	size(15 80) range(3840 2160)
shellout 词云.html

**********************
********一次性分词
*********************
use E:\Stata大会\文本分析/大众点评日料评论sample.dta,clear
gen v=""
qui forval i=1/100{
	replace v=v+";"+comments[`i']
	}
replace v=ustrregexra(v,"\t","")
local a=v[1]
di `"`a'"'
clear all
cd  "E:\Stata大会\文本分析\词云图\大众点评"
tempname handle
file open `handle' using 分词.py, replace text write
file write `handle' `"# -*- coding: utf-8 -*-"' _n
file write `handle' `"import jieba.posseg"' _n
file write `handle' `"jieba.load_userdict("E:/Stata教程/文本分析/dict.txt")"' _n
file write `handle' `"string ='`a''"'_n
file write `handle' `"seg_list = jieba.posseg.cut(string)"' _n
file write `handle' `"f=open("sample.txt","w",encoding="utf-8")"' _n
file write `handle' `"for word in seg_list:"' _n
file write `handle' `"	f.write(word.word+" "+word.flag+"\n")"' _n
file write `handle' `"f.close"'             
file close `handle'
! python 分词.py 

clear
cd E:\Stata大会\文本分析\词云图\大众点评
infix strL v 1-12000 using sample.txt,clear
split v,p(" ")
drop v 
rename (v1 v2) (keyword flag)
*保留名词动词形容词
replace flag=subinstr(flag," ","",1)
keep if ustrregexm(flag, "^[anv]")
*删除单字
drop if ustrlen(keyword) == 1
compress
keep keyword

*删除停用词
preserve
cd E:\Stata大会\文本分析
import delimited using 停用词表.txt, clear ///
	encoding("utf-8") varname(nonames)
outsheet using 停用词表.txt, replace nonames noquote
levelsof v1, local(keyword)
restore
foreach word in `keyword' {
	drop if keyword == "`word'"
}

*统计词频
bysort keyword: gen frequency = _N
duplicates drop
gsort -frequency
wordcloud keyword frequency using 词云.html , replace ///
	size(15 80) range(3840 2160)
shellout 词云.html

*******************************************************************************
*                                                                              *
*                                    *结束*                                  
*                                                                              *
********************************************************************************


